import { IDBExecuter } from '../interfaces/dbexecuter.adapter';
import { DBAction } from './db.action';
import { ParamsHolder } from './paramsHolder';
import * as Neo4JDriver from 'neo4j-driver';
export declare class CypherAction extends DBAction {
    private query;
    private rawParams;
    protected isFunctionOverrided: boolean;
    constructor(query: string, rawParams: any, adapter?: IDBExecuter);
    protected buildQueryBody(): string;
    /**
     * It will execute the action into the Data Base, using Neo4J Driver to connect and execute the cypher, using the cypher and parameters assigned to this action
     * After executing the action it will try to parse the result to a more friendly JSON form.
     * @returns
     */
    executeRaw(): Promise<Neo4JDriver.QueryResult>;
    /**
     * set query parameters to be executed among your query
     * @param {any} parameters: a set of parameters for the database
     * @return {DBAction} The same aciton to chain functionalities
     */
    setQueryParameters(parameters: any): DBAction;
    overrideReturnAction(): DBAction;
    setEntities(): DBAction;
    getParamHolder(): ParamsHolder;
}
