import { Node, Relationship } from '../../../../../../core/entities';
import { CypherBuilder } from '../cypher.builder';
import { InnerGenerator } from './inner.builder';
export declare abstract class PatternBuilder extends CypherBuilder {
    protected usedNodes: Node[];
    protected PREFIX_EMPTY: string;
    protected PREFIX_NON_EMPTY: string;
    protected PATTERN_BREAK: string;
    protected QUERY_PREFIX: string;
    protected innerFn: InnerGenerator;
    getUsedNode(): Node[];
    protected buildCypher(usedNodes?: Node[]): string;
    protected abstract getNodesAndRelationshipsPatternString(): [string, string];
    protected patternWithRelationshipFirst(): [string, string];
    protected patternWithNodesFirst(): [string, string];
    private getRelationships;
    private getNodes;
    private buildRelsMatch;
    protected buildRelMatch(rel: Relationship): string;
    private buildNodesMatch;
    protected buildNodeMatch(node: Node): string;
    private prepareQuery;
    protected getEmptyPrefix(): string;
    protected getNonEmptyPrefix(): string;
    protected attachQueryPrefix(query: string): string;
}
