import { IGraphEntity } from '../../../../../../core/entities/neoEntities/graph.entity';
import { Property } from '../../../../../../core/entities/neoEntities/property.entity';
import { ParamsHolder } from '../../../../../../core/entities/paramsHolder';
import { CypherBuilder } from '../cypher.builder';
export declare abstract class PropertyAssignerBuilder extends CypherBuilder {
    private doesFirstPass;
    protected filterAndConditionFactory: (property: Property, propertyName: string, paramValue: string) => string;
    protected operatorFactory: (property: Property) => string;
    protected indexFilterCreator: (propery: Property) => string;
    protected entities: IGraphEntity[];
    protected params: ParamsHolder;
    protected PREFIX: string;
    constructor(lineBreak: string, tabChar: string);
    protected buildCypher(): string;
    protected generateFiltersQueryString(): string;
    protected makeFiltersForEntity(entity: IGraphEntity): string;
    protected generateFilterStringForEntityWithId(entity: IGraphEntity): string;
    protected generateFiltersStringForEntity(entity: IGraphEntity): string;
    private generateFiltersStringForProperty;
    protected isPropertySelectable(property: Property): boolean;
    private generateOperator;
    protected getStringIfNoOperator(): string;
    protected addOperatorStringDecorator(operatorString: string): string;
    private generateFilterWithCondition;
    protected generatePropertyName(property: Property, parentEntity: IGraphEntity): string;
    private appendPrefix;
}
